/*
 *	fram.c
 *
 *	ATARI VCS/EMU
 *
 *	* Tue Mar 15 20:31:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

// extern int CYCLE; /* RAMɔzu */
// extern int NOW;   /* RAMɔzu */
asm("
	.code				; RAMɔzu邽߁Aϐł.codeZNVƂ܂B
	.align	2
	.global	CYCLE
	.global	NOW
CYCLE:
	.word	0
NOW:
	.word	0
");

// int/*%data*/ w65c02_read(/*%addr*/)
asm("
	.code
	.align	1
	.global	w65c02_read
w65c02_read:
	ld.w	%r9, %r0		; %r9 = addr>>7
	xsrl	%r9, 7
	xjreq	_w65c02_read_tia	; $0000-$007F: TIA
	xcmp	%r9, 5			; /*0x280>>7=5*/
	xjrlt	_w65c02_read_mem	; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	xjreq	_w65c02_read_pia	; $0280-$02FF: PIA
	; /** FALLTHRU **/		; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_w65c02_read_mem:
	ext	mem@ah
	ext	mem@al
	ld.ub	%r1, [%r0]
	ret
	;----------------------
_w65c02_read_tia:
	xcall.d	w65c02_leave
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r12, [NOW]		; %r12  = NOW
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	;
	xcall	tia_read		; return tia_read(NOW, addr)
	xjp.d	w65c02_enter
	ld.w	%r1, %r10		; %r10 -> %data *delay*
	;----------------------
_w65c02_read_pia:
	xcall.d	w65c02_leave
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r12, [NOW]		; %r12  = NOW
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	;
	xcall	pia_read		; return pia_read(NOW, addr)
	xjp.d	w65c02_enter
	ld.w	%r1, %r10		; %r10 -> %data *delay*
");

// void w65c02_write(/*%addr,%data*/)
asm("
	.code
	.align	1
	.global	w65c02_write
w65c02_write:
	ld.w	%r9, %r0		; %r9 = addr>>7
	xsrl	%r9, 7
	xjreq	_w65c02_write_tia	; $0000-$007F: TIA
	xcmp	%r9, 5			; /*0x280>>7=5*/
	xjrlt	_w65c02_write_mem	; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	xjreq	_w65c02_write_pia	; $0280-$02FF: PIA
	ret				; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_w65c02_write_mem:
	ext	mem@ah
	ext	mem@al
	ld.b	[%r0], %r1
	ret
	;----------------------
_w65c02_write_tia:
	xcall.d	w65c02_leave
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r12, [NOW]		; %r12  = NOW
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	;
	xcall.d	tia_write		; retval = tia_write(NOW, addr, data)
	ld.w	%r14, %r1		; %r14 <- %data
	xcmp	%r10, 0			; if(retval) { /* WSYNC̏ꍇ̂ */
	xjreq	w65c02_enter
	sub	%r15, %r10		;   w65c02.cycle -= retval
	xld.w	[w65c02+12], %r15	;   w65c02.cyclẽItZbg=12Ɉˑ!!
	xjp	w65c02_enter		; }
	;----------------------
_w65c02_write_pia:
	xcall.d	w65c02_leave
	ld.w	%r13, %r0		; %r13 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r12, [NOW]		; %r12  = NOW
	sub	%r9, %r15		; %r9   =        CYCLE - w65c02.cycle
	add	%r12, %r9		; %r12  = NOW + (CYCLE - w65c02.cycle)
	xld.w	[NOW], %r12		; NOW   = NOW + (CYCLE - w65c02.cycle)
	xld.w	[CYCLE], %r15		; CYCLE =                w65c02.cycle
	;
	xcall.d	pia_write		; pia_write(NOW, addr, data)
	ld.w	%r14, %r1		; %r14 <- %data
	xjp	w65c02_enter
");

